tag @s add dol_match_initiated
scoreboard players reset @s dol_tick

#FLAG PLAYERS
execute as @a if score @s UID = @e[tag=dol_match_initiated,limit=1,sort=nearest] dol_request_id run tag @s add request_matchmake
execute as @a if score @s UID = @e[tag=dol_match_initiated,limit=1,sort=nearest] dol_opponent_id run tag @s add opponent_matchmake
tag @a[tag=request_matchmake,limit=1,sort=nearest] add matchmake
tag @a[tag=opponent_matchmake,limit=1,sort=nearest] add matchmake


#CHANGE MODEL
execute on passengers as @s[tag=dol_display] run data merge entity @s {item:{id:"minecraft:paper",Count:1b,tag:{CustomModelData:15}},brightness:{sky:15,block:15},start_interpolation:0,interpolation_duration:30,transformation:{left_rotation:[0f,0f,0f,1f],right_rotation:[0f,0f,0f,1f],translation:[0f,3f,0f],scale:[2f,2f,2f]}}

#MATCH ID
execute store result score @s match_id run random value 1000000..9999999
execute as @a[tag=matchmake,limit=2,sort=nearest] run scoreboard players operation @s match_id = @e[tag=dol_match_initiated,limit=1,sort=nearest] match_id

scoreboard players reset @a[tag=matchmake] match_death
scoreboard players reset @a[tag=matchmake] match_timer
scoreboard players reset @a[tag=matchmake] match_logoff
scoreboard players reset @a[tag=matchmake] direct_damage

execute as @a[tag=matchmake] run function main:utility/teleportation/savelocation
tag @a[tag=matchmake] add xp_protection

#MATCH TELLRAW
tellraw @a ["",{"text":"\uE506","color":"gold"},{"selector":"@p[tag=request_matchmake]","color":"white"},{"translate":"dol.and","color":"gold"},{"selector":"@p[tag=opponent_matchmake]","color":"white"},{"translate":"dol.message.match_start","color":"gold"}]

#PROTECTION
effect give @a[tag=matchmake] resistance 5 200 false

#REMOVE FLAGS
tag @a[tag=request_matchmake] remove request_matchmake
tag @a[tag=opponent_matchmake] remove opponent_matchmake
tag @a[tag=matchmake] remove matchmake

#SUMMON
data merge entity @s {width:0.0f,height:0.0f}

summon area_effect_cloud ~ ~ ~ {Duration:99999999,Tags:["dol_area","dol_main","unset"]}
ride @e[tag=dol_area,tag=unset,limit=1,sort=nearest] mount @s
tag @e[tag=dol_area,tag=unset,limit=1,sort=nearest] remove unset

playsound minecraft:entity.phantom.ambient block @a ~ ~ ~ 1 0.2 0
playsound minecraft:entity.phantom.ambient block @a ~ ~ ~ 0.8 0.5 0
playsound minecraft:entity.evoker.cast_spell block @a ~ ~ ~ 0.3 0.3 0
playsound minecraft:block.beacon.deactivate block @a ~ ~ ~ 0.3 0.3 0

#END
tag @s remove dol_match_initiated
tag @s add dol_match_started